/**
 @class AnimGrass
 @author YI ZHANG
 @date 2023/4/19
 @desc
 **/

import * as cc from "cc";
import {CCBoolean, CCFloat, Collider2D, Component, Contact2DType, IPhysics2DContact, RigidBody2D} from "cc";
import GrassIkComp from "./GrassIkComp";

const {ccclass, property,menu,executeInEditMode} = cc._decorator;
export interface AnimGrassData {
}
let v3_1 = cc.v3();
let v3_2 = cc.v3();
@ccclass("AnimGrass")
@menu("物体/动画草")
@executeInEditMode()
export default class AnimGrass extends Component {
    protected beginContact: boolean = false;
    private spine: cc.sp.Skeleton = null!;
    colliderMap = new Set<string>();
    private speedDir: number = 0;
    init = true;
    @property({type : CCFloat,displayName: "ik大小"})
    private ikSize : number = 2;
    @property({type : CCFloat,displayName: "重力大小"})
    private gravityScale : number = 0;
    @property({type : CCBoolean,displayName: "施加回归位置力"})
    private recoveryPos : boolean = true;
    private isShow: boolean = true;
    protected onLoad() {
        this.spine = this.getComponent(cc.sp.Skeleton)!;
        this.isShow = true;

        if(!this.init){
            return;
        }
        this.init = false;
        let names = this.spine.querySockets();
        let bodyMap = new Map<string,GrassIkComp>();
        let connectMap = new Map<string,string>();
        for(let i = 0;i < names.length;++i){
            let name = names[i];
            if(name.indexOf("ik") !== -1){
                name = name.substring(name.lastIndexOf("/") + 1,name.length);
                let node = new cc.Node();
                node.active = false;
                this.node.addChild(node);
                let list = name.split("|");
                bodyMap.set(list[0], node.addComponent(GrassIkComp)!.init(this.spine,name,this.ikSize,this.recoveryPos,this.gravityScale));
                if(list[1]){
                    connectMap.set(list[0],list[1] == "0" ? "" : "ik_" + list[1]);
                }
            }
        }
    }


}

